/*
 * extb plugin to VDR (C++)
 *
 * (C) 2004 Andreas Brachold <vdr04-at-deltab-dot-de>
 *
 * This code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html
 */

#ifndef ___SETUP_EXTB_H___
#define ___SETUP_EXTB_H___

#define memberof(x) (sizeof(x)/sizeof(*x))
#define LED_CNT 6
#define OUT_CNT 4

struct cExtbSetup 
{
  int   m_nMuteMode;
  int   m_nLEDMode[LED_CNT];
  int   m_nOutputMode[OUT_CNT];
  int   m_bHideMainMenuEntry;
  
  enum eMuteModes
  {
  eMuteModes_Analog = 0,
  eMuteModes_Digital,
  eMuteModes_AnalogDigital,
  // the follow value is use only to determine array size
  eMuteModes_Cnt
  };

  enum eLEDModes
  {
  // Don't use the LED or Output channel
  eLEDModes_Unused = 0,
  // Instant on or off
  eLEDModes_Off,
  eLEDModes_AlwaysOn,
  // Recording state
  eLEDModes_AnyRecording,
  eLEDModes_RecordingOnCard1,
  eLEDModes_RecordingOnCard2,
  eLEDModes_RecordingOnCard3,
  eLEDModes_RecordingOnCard4,
  // Replay state
  eLEDModes_AnyReplay,
  eLEDModes_ReplayVDR,
  eLEDModes_ReplayDVD,
  eLEDModes_ReplayMP3,
  //Channelfeature
  eLEDModes_ChannelHasCA,
  eLEDModes_ChannelHasDpid,
  eLEDModes_ChannelHasApid,
  eLEDModes_ChannelHasTpid,
  eLEDModes_ChannelHasVpid, 
  eLEDModes_ChannelIsRadio, //if channel has no vpid
  // Audio state
  eLEDModes_AudioMute,
  eLEDModes_AudioNotMute,
  // DVD Plugin Playbackmodes
  eLEDModes_DVD_AC3,
  eLEDModes_DVD_DTS,
  eLEDModes_DVD_PCM,
  eLEDModes_DVD_MP2,
  eLEDModes_DVD_4_3,
  eLEDModes_DVD_16_9,
  // MP3 Plugin Playbackmodes
  eLEDModes_MP3_Shuffle,
  eLEDModes_MP3_Loop,    
  // the follow value is use only to determine array size
  eLEDModes_Cnt
  };

  
  static const char * m_szMuteModes[eMuteModes_Cnt];
  static const char * m_szLEDModes[eLEDModes_Cnt];
  
  cExtbSetup(void);
  /// Parse our own setup parameters and store their values.
  bool SetupParse(const char *szName, const char *szValue);
  
  void LoadTranslatedStings(void);
  

  
};

/// The exported one and only Stored setup data
extern cExtbSetup theSetup;

#endif  //___SETUP_EXTB_H___
